<?php
namespace App\Controllers;

use Silex\Application;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use GuzzleHttp\Client;

class IndexController extends BaseController{
	public function index(){
		return new Response(file_get_contents(__DIR__."/../resources/index.html"));
	}

	public function orders(Request $req){
		$min = str_replace(' ', 'T', $req->get('min')).":00+10:00";
		$max = str_replace(' ', 'T', $req->get('max')).":00+10:00";

		$client = new Client(['base_uri' => $this->app['shopify']['url']]);
		try {
			$ordersResponse = $client->get("admin/orders.json?limit=250&created_at_min=".$min."&created_at_max=".$max);
			$orders = json_decode($ordersResponse->getBody(true), true)['orders'];

			
			$file = fopen(__DIR__.'/../storage/output.csv', 'w+');

			fputcsv($file, array('C_CONSIGNMENT_ID', 'C_POST_CHARGE_TO_ACCOUNT', 'C_CHARGE_CODE', 'C_MERCHANT_CONSIGNEE_CODE', 'C_CONSIGNEE_NAME', 'C_CONSIGNEE_BUSINESS_NAME', 'C_CONSIGNEE_ADDRESS_1', 'C_CONSIGNEE_ADDRESS_2', 'C_CONSIGNEE_SUBURB', 'C_CONSIGNEE_STATE_CODE', 'C_CONSIGNEE_POSTCODE', 'C_CONSIGNEE_COUNTRY_CODE', 'C_SIGNATURE_REQUIRED', 'C_CONSIGNEE_EMAIL', 'C_EMAIL_NOTIFICATION', 'A_ACTUAL_CUBIC_WEIGHT'));
			fputcsv($file, array('IGNORED', 'OPTIONAL', 'MANDATORY', 'MANDATORY', 'MANDATORY', 'OPTIONAL', 'MANDATORY', 'OPTIONAL', 'MANDATORY', 'MANDATORY', 'MANDATORY', 'MANDATORY', 'OPTIONAL', 'MANDATORY', 'OPTIONAL', 'MANDATORY'));

			foreach ($orders as $order){
				if (strpos($order['shipping_lines'][0]['title'], 'Express') !== false || strpos($order['shipping_lines'][0]['title'], 'express') !== false){
					$shippingcode = '3J35';
				} else {
					$shippingcode = '7D55';
				}
				
				fputcsv($file, array(
					'',
					'7017094',
					$shippingcode,
					'N',
					$order['shipping_address']['name'],
					$order['shipping_address']['company'],
					$order['shipping_address']['address1'],
					$order['shipping_address']['address2'],
					$order['shipping_address']['city'],
					$order['shipping_address']['province_code'],
					$order['shipping_address']['zip'],
					$order['shipping_address']['country_code'],
					'A',
					$order['email'],
					'TRACKADV',
					'0.5'
				));
			}
			fclose($file);
			
			$stream = function() use ($file){
				readfile(__DIR__.'/../storage/output.csv');
			};
			return $this->app->stream($stream, 200, array(
				'Content-Type' => 'text/csv',
				'Content-length' => filesize(__DIR__.'/../storage/output.csv'),
				'Content-Disposition' => 'attachment; filename="output.csv"'
			));
			//return new Response();
			//return new Response(file_get_contents(__DIR__.'/../storage/output.csv'));
		} catch (GuzzleHttp\Exception\TransferException $e) {
			return $this->app->json(array('error' => 'Shopify Error: '.$e));
		}
	}
}